<?php

class uygunsms extends AktuelSms {
	private $apiUrl = '';
	function __construct($message,$gsmnumber){
		$this->message = $this->utilmessage($message);
		$this->gsmnumber = $this->utilgsmnumber($gsmnumber);
		$this->apiUrl = 'http://api.mesajpaneli.com/';
	}

	function send(){
		if($this->gsmnumber == "numbererror"){
			$log[] = ("Number format error.".$this->gsmnumber);
			$error[] = ("Number format error.".$this->gsmnumber);
			return null;
		}
		$params = $this->getParams();

		$request = [
			'islem' => 1,
			'user' => $params->user,
			'pass' => $params->pass,
			'mesaj' => $this->message,
			'numaralar' => $this->gsmnumber,
			'baslik' => $params->senderid
		];

		$log[] = "Request url: ".json_encode($request);
		$result = $this->createRequest('index.php', $request);
		$result = $this->response($result);

		$log[] = "Sunucudan dönen cevap: ".$result;

		$resultx = explode(":", $result[1]);


		$msgId = null;

		if ($resultx[0] == "OK") {
			$msgId = $resultx[1];

			$this->addLog("Message sent.");
			$log[] = "Message sent";
			$log[] = "Message id: ".$msgId;
		}else{
			$log[] = "Mesaj gönderilemedi. Hata: ".$result[2];
			$error[] = "Mesaj gönderilirken hata oluştu. Hata: ".$result[2];
		}

		return array(
			'log' => $log,
			'error' => $error,
			'msgid' => $msgId,
		);
	}

	function balance(){
		$params = $this->getParams();

		if($params->user && $params->pass){
			$result = $this->createRequest('index.php', [
				'islem' => 2,
				'user' => $params->user,
				'pass' => $params->pass,
			]);

			$response = $this->response($result);
			return $response[1];
		}else{
			return null;
		}
	}

	function report($msgid){
		$params = $this->getParams();

		if($params->user && $params->pass && $msgid){
			$result = $this->createRequest('request.php', [
				'islem' => 6,
				'ref' => $msgid,
				'user' => $params->user,
				'pass' => $params->pass,
			]);
			$response = $this->response($result);
			//$response = explode(':',$response[1]);
			if($response[1] == 'OK:RAPOR_CEKILDI'){
				return "success";
			}else{
				return "error";
			}
		}else{
			return null;
		}
	}

	function utilgsmnumber($number){
		if (strlen($number) == 10) {
			$number = '90' . $number;
		} elseif (strlen($number) == 11) {
			$number = '9' . $number;
		}

		if (substr($number, 0, 3) != "905") {
			return "error";
		}

		return $number;
	}

	private function response($resp){
		return explode('|',$resp);
		/*
		$first = explode('|',$resp);
		$responseType = $first[0];
		$responseDetail = explode(':',$first[1]);
		$status = $responseDetail[0];
		$id = $responseDetail[1];
		return [
			'type' => $responseType,
			'status' => $status,
			'id' => $id,
		];*/
	}
	private function createRequest($addonUrl,$params=[]){
		return curlCall($this->apiUrl.$addonUrl,$params);
	}

	private function utilmessage($message){
		$changefrom = array('ı', 'İ', 'ü', 'Ü', 'ö', 'Ö', 'ğ', 'Ğ', 'ç', 'Ç','ş','Ş');
		$changeto = array('i', 'I', 'u', 'U', 'o', 'O', 'g', 'G', 'c', 'C','s','S');
		$message = str_replace($changefrom, $changeto, $message);
		return $message;
	}
}

return array(
	'value' => 'uygunsms',
	'label' => 'uygunsms',
	'fields' => array(
		'user','pass'
	)
);
